SystemOrganization addCategory: #'MC2-Meta-Repository-Network'!

MDRepositoryElement subclass: #MDNetRepositoryElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Repository-Network'!

!MDNetRepositoryElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:32'!
handleWith: anObject
	^ anObject handleNetRepository: self! !

MDRepositoryAdaptor subclass: #MDNetRepositoryAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Repository-Network'!

!MDNetRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/18/2009 22:39'!
createRepository: properties
	^ MDNetRepository
		id: element id
		host: properties host
		port: properties port! !

!MDNetRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/18/2009 23:02'!
isUpToDate: properties
	| repository locator |
	repository := self repositoryIfAbsent: [^ false].
	locator := repository locator.
	
	^ locator host = properties host
		and: [locator port = properties port]! !

!MDNetRepositoryAdaptor methodsFor: 'private' stamp: 'cwp 10/21/2009 23:38'!
modify: aRepository with: properties
	aRepository link: (MDNetLink 
						host: properties host 
						port: properties port)! !

!MDNetRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/21/2009 20:38'!
update: properties 
	| locator |
	locator := (self repositoryIfAbsent: [ ^ properties ]) locator.
	^ properties
		host: locator host;
		port: locator port;
		yourself! !
